<?
// vim600: fdm=marker
/*
- Software: Mastermind Game written with Javascript+PHP
- License:
  GPL v2 (Version 2, June 1991) 
  (md5sum of the license textfile b2a3c538b55bd02772ed9c8a9e259af2)
  with the exception that any other version's need the authors aprove.
- Author: Thomas Lunig (thomas.lussnig@bewegungsmelder.de)
*/
/*
  Description:
  Goal of this implementation is trustwoth and cheat safe
  Steps taken to meetthis goals:
  - Client "chose" an random "SEED" witch he seends to the server (so server can't use set of pre calculated SHA1 values)
  - Server "chose" an random "RAND" save it for this session and only send it to the client on LOST/WIN situation for checking
  - Server calculate an "CODE" and send to the client SHA1(CODE,RAND,SEED)
  - During the game RAND,SEED is fixed.
  - At the end the Server send with the WIN/LOST message also the "CODE" so the clientcan check B/W marks and with the SHA1 hash
    from the beginning if the server did not change the code during the game.

  - Currently the is one leck in the security:
    since client send "CHECK" and "SEED" as first message and do no initial Handshake the server can chose the CODE after he knew
    the first CHECK value.
    This was done because the gae should be fast to use (work with the first display).
  - Also the SEED is predefined from the Server in the Javascript part it's no lack it's no leak in the protocol since the client
    must not use this seed.

  - I do not know how hard it is to Compute an set of alternative messages to an given SHA1 hash when SEED is preset.
    But i read somehere that for MD5 this should be posible (if an matching set exist) in about 10 Hours. I do not know
    if it's true, but the program work with any hashing where the hash funktion is availabe in PHP+JavaScript.
*/
require "session_mysql.php";
require "sha1.php";
session_name("mastermind");
session_start();
hiddenSession();
$session_name=$sess->classname;
$session_wert=$sess->id;
function blackMatch($a,$b) {{{ // Liefert zurck wieviele elem(A) in B an gleicher Stelle sind
	global $black1,$black2,$ma,$mb;
	$black1=array(0,0,0,0);
	$black2=array(0,0,0,0);
	$ma=$a;
	$mb=$b;
	if(strlen($a)!=4) return 0;
	if(strlen($b)!=4) return 0;
	$ret=0;
	for($i=0;$i<4;$i++)
		if(substr($a,$i,1)==substr($b,$i,1)) {
			$ret++;
			$black1[$i]=1;
			$black2[$i]=1;
			}
	return $ret;
	}}}
function whiteMatch(     ) {{{	// Liefert zurck ob wieviele elem(A) in B vorkommen
	global $black1,$black2,$ma,$mb;
	$a=$ma;
	$b=$mb;
	$ret=0;
	for($Ia=0;$Ia<4;$Ia++) {
		if($black1[$Ia]==1) continue;
		$A=substr($a,$Ia,1);
		for($Ib=0;$Ib<4;$Ib++) {
			if($black2[$Ib]==1) continue;
			if(substr($b,$Ib,1)==$A) {
				$ret++;
				$black1[$Ia]=1;
				$black2[$Ib]=1;
				break;
				}
			}
		}
	return $ret;
	}}}
function Mastermind($pos_x,$pos_y) {{{
	global $POS,$session_name,$session_wert;
	global $black,$white,$CHECK,$RAND;
	global $HASH,$code,$CODE;
	global $_POST,$_GET;
	if( isset($_GET )) {{{
		if(isset($_GET ["SEED"])) $SEED=$_GET ["SEED"];
		if(isset($_GET ["hist"])) $hist=$_GET ["hist"];
		if(isset($_GET ["last"])) $last=$_GET ["last"];
		}}}
	if( isset($_POST)) {{{
		if(isset($_POST["SEED"])) $SEED=$_POST["SEED"];
		if(isset($_POST["hist"])) $hist=$_POST["hist"];
		if(isset($_POST["last"])) $last=$_POST["last"];
		}}}
	if(!isset($SEED )) $SEED=rand();
	if(!isset($CODE )) $CODE=rand(1,6).rand(1,6).rand(1,6).rand(1,6);
	if(!isset($RAND )) $RAND=calcSHA1($UNIQUE_ID.rand());
	session_register("CODE");
	session_register("RAND");
//	global $sess;
//	$sess->register("CODE");
//	$sess->register("RAND");
	$HASH=calcSHA1($CODE.";".$RAND.";".$SEED);
	$POS=0;
	if(isset($last) && isset($hist)) {{{
		if(calcSHA1($last.';'.$hist.';'.$RAND)) {
			$POS=$last;
			$CHECK=explode(";",$hist);
			}
		}}}
	if($POS==0)	$CHECK=Array("0000","0000","0000","0000","0000","0000","0000","0000","0000","0000");
	if(isset($_POST)) if(isset($_POST["code"])) if($_POST["code"]) {{{
		$CHECK[$POS]=$_POST["code"];
		$POS++;
		}}}
	if(isset($_GET )) if(isset($_GET ["code"])) if($_GET ["code"]) {{{
		$CHECK[$POS]=$_GET["code"];
		$POS++;
		}}}
	$w=$b="";
	for($i=0;$i<10;$i++) {{{
		$b=$b.blackMatch($CHECK[$i],$CODE).",";
		$w=$w.whiteMatch().",";
		}}}
	$sicher=calcSHA1($POS.";".implode(";",$CHECK).";".$RAND);
	return '
	<style  type="text/css" src="games/mastermind.css"> </style>
	<script 		src="games/sha1.js"	  > </script>
	<script 		src="games/mastermind.js" > </script>
	<script>
		var POS ='.$POS.';
		var sess_name="'.$session_name.'";
		var sess_wert="'.$session_wert.'";
		var black=new Array('.$b.'0);
		var white=new Array('.$w.'0);
		var CHECK="'.implode(";",$CHECK).'";
		var SEED="'.$SEED.'";
		var HASH="'.$HASH.'";
		var code="'.$code.'";
		var RAND="'.(($POS>=10 || $CODE==$code)?$RAND:"").'";
		var CODE="'.(($POS>=10 || $CODE==$code)?$CODE:"0000").'";
		var mode='.(($CODE==$code)?0:(($POS>=10)?1:2)).';
		var rbkid='0';
		var sicher="'.$sicher.'";
		var hist =CHECK.split(";");
		var check=calcSHA1(CODE+";"+RAND+";"+SEED);
	</script>
	<script>
		Mastermind('.$pos_x.','.$pos_y.');
	</script>
	';
	}}}
?>
<html>
	<body>
		<? echo Mastermind(10,10) ?>
	</body>
</html>
