<?
/*
- Software: Mastermind Game written with Javascript+PHP
- License:
  GPL v2 (Version 2, June 1991) 
  (md5sum of the license textfile b2a3c538b55bd02772ed9c8a9e259af2)
  with the exception that any other version's need the authors aprove.
- Author: Thomas Lunig (thomas.lussnig@bewegungsmelder.de)

- Source:
 * Javascript implementation from Paul Johnston
 * See http://pajhome.org.uk/site/legal.html for details.
*/
function hex($num) {{{
	$hex_chr = "0123456789abcdef";
	$str = "";
	for($j = 7; $j >= 0; $j--) {
		$str .= substr($hex_chr,($num >> ($j * 4)) & 15,1);
		}
	return $str;
	}}}
function str2blks_SHA1($str) {{{
	$nblk = ((strlen($str) + 8) >> 6) + 1;
	$blks = Array($nblk * 16);
	for($i = 0; $i < $nblk * 16; $i++) $blks[$i] = 0;
	for($i = 0; $i < strlen($str); $i++)
		$blks[$i >> 2] |= ord(substr($str,$i,1)) << (24 - ($i % 4) * 8);
	$blks[$i >> 2] |= 0x80 << (24 - ($i % 4) * 8);
	$blks[$nblk * 16 - 1] = strlen($str) * 8;
	return $blks;
	}}}
function safe_add($x, $y) {{{
	return ($x+$y) & 0xFFFFFFFF;
	$lsw = ($x & 0xFFFF) + ($y & 0xFFFF);
	$msw = ($x >> 16) + ($y >> 16) + ($lsw >> 16);
	return ($msw << 16) | ($lsw & 0xFFFF);
	}}}
function rol($num, $cnt) {{{
	if($cnt==32) return $num;
	$tmp_a=$num & 0x7fffffff;
	$tmp_a=($tmp_a>>1);
	if($num<0) $tmp_a|=0x40000000;
	return ($num << $cnt) | ($tmp_a >> (31 - $cnt));
	}}}
function ft($t, $b, $c, $d) {{{
	if($t < 20) return ($b & $c) | ((~$b) & $d);
	if($t < 40) return $b ^ $c ^ $d;
	if($t < 60) return ($b & $c) | ($b & $d) | ($c & $d);
	return $b ^ $c ^ $d;
	}}}
function kt($t) {{{
	if($t<20) return  1518500249;
	if($t<40) return  1859775393;
	if($t<60) return -1894007588;
		  return  -899497514;
	}}}
function calcSHA1($str) {{{
	$x = str2blks_SHA1($str);
	$w = Array(80);
	$a =  1732584193;
	$b =  -271733879;
	$c = -1732584194;
	$d =   271733878;
	$e = -1009589776;
	for($i = 0; $i < count($x); $i += 16) {
		$olda = $a;
		$oldb = $b;
		$oldc = $c;
		$oldd = $d;
		$olde = $e;
		for($j = 0; $j < 80; $j++) {
			if($j < 16) $w[$j] = $x[$i + $j];
			else $w[$j] = rol($w[$j-3] ^ $w[$j-8] ^ $w[$j-14] ^ $w[$j-16], 1);
			$t = safe_add(safe_add(rol($a, 5), ft($j, $b, $c, $d)), safe_add(safe_add($e, $w[$j]), kt($j)));
			$e = $d;
			$d = $c;
			$c = rol($b, 30);
			$b = $a;
			$a = $t;
			}
		$a = safe_add($a, $olda);
		$b = safe_add($b, $oldb);
		$c = safe_add($c, $oldc);
		$d = safe_add($d, $oldd);
		$e = safe_add($e, $olde);
		}
	return hex($a).hex($b).hex($c).hex($d).hex($e);
	}}}
// vim600: fdm=marker	
?>
